module ForemanOsc
  module HostParameterExtensions
    extend ActiveSupport::Concern

    included do
      validate :rw_nfsroot_path_unique, if: :rw_host_nfsroot_path?
    end

    def rw_nfsroot_path_unique
      rw_hosts = self.host.hostgroup.hosts
      other_params = self.class.where.not(id: self.id).where(name: 'nfsroot_path', value: value, host: rw_hosts)
      if ! other_params.empty?
        errors.add(:value, "should be unique for RW hosts")
      end
    end

    def rw_host_nfsroot_path?
      self.name == 'nfsroot_path' && self.host.hostgroup.present? && self.host.hostgroup.name == 'rw'
    end

  end
end
